// forall d:Door . d = Open => [CloseDoor(d)] d = Closed
action CloseDoor(d) = {
pre = d:Door, d:Open
effect = d:Closed
}

// forall d:Door . d = Closed => [OpenDoor(d)] d = Open
action OpenDoor(d) = {
pre = d:Door, d:Closed
effect = d:Open
}

/* forall time:Time . forall d:Door 
   . [DoorControl(time,d)] PHI <=> 
     [((time = Day)? ; NightComes(time) ; DoorControl(time,d)) 
     + (not(time=Day) /\ time=Night /\ d:Closed)?; (d=Closed)?
     + (not(time=Day) /\ not(time=Night /\ d:Closed) /\ time=Night /\ not d:Closed)? ; CloseDoor(d)] PHI 
*/
function DoorControl(time,d) = {
  switch 
  case time:Day => init NightComes(time) ; DoorControl(time,d) 
  case time:Night and d:Closed => d:Closed?
  case time:Night and d:Open => CloseDoor(d) 
}

/*
forall sit:Situation; t:Time ;  d:Door
. [EmergencyOpen(sit,d,t)] PHI <=> 
[(t=Day? ; System(sit,t,d))
|(not(t=Day) /\ d=Closed? ; OpenDoor(d) ; EmergencyMonitor(sit,d) ; System(sit,t,d))
|(not(t=Day) /\ not(d=Closed) /\ d=Open? ; EmergencyMonitor(sit,d) ; System(sit,t,d))] PHI ;
*/
function EmergencyOpen (sit,d,time) = {
 init EmergencyHappens(sit,time);
 switch 
  case time:Day => System(sit,time,d)
  case d:Door and d:Closed => OpenDoor(d) ; init EmergencyMonitor(sit,d) ; System(sit,time,d)
  case d:Door and d:Open => init EmergencyMonitor(sit,d) ; System(sit,time,d)
}

/*
forall  sit:Situation ; t:Time ; d:Door 
. [System(sit,t,d)] PHI <=>
  [DoorControl(t,d) ; EmergencyOpen(sit,d,t)] PHI ;
*/
function System (sit,time,d) = {
 DoorControl(time,d) ; EmergencyOpen(sit,d,time)
}

