
;; very simple ship mode
;; by Dominik Dietrich

(add-to-list 'auto-mode-alist '("\\.ont\\'" . ship-mode))
(add-to-list 'auto-mode-alist '("\\.prg\\'" . ship-mode))
(add-to-list 'auto-mode-alist '("\\.mon\\'" . ship-mode))

(defvar ship-keywords
  '("function" "process" "action" "monitor")
  "ship keywords.")

(setq ship-keywords '("function" "process" "action" "monitor"))

(defvar ship-block-keywords 
  '("switch" "if" "case" "forall" "init" "pre" "effect" "exec" "delete" "not" "and" "all" "ex" "+>" ";" "=>" "|")
  "ship keywords.")

(setq ship-block-keywords '("switch" "if" "case" "forall" "init" "pre" "effect" "exec" "delete" "not" "and" "all" "ex" "+>" ";" "=>" "|"))

(defvar ship-keywords-regexp nil)
(setq ship-keywords-regexp (regexp-opt ship-keywords 'words))

(defvar ship-block-keywords-regexp (regexp-opt ship-block-keywords 'words))
(setq ship-block-keywords-regexp (regexp-opt ship-block-keywords 'words))

(setq ship-font-lock-keywords
  `(
    (,ship-keywords-regexp . font-lock-keyword-face)
    (,ship-block-keywords-regexp . font-lock-constant-face)
    ("function[[:space:]]+\\([_A-Za-z0-9]+\\)" (1 font-lock-function-name-face))
    ("process[[:space:]]+\\([_A-Za-z0-9]+\\)" 1 font-lock-function-name-face)
    ("monitor[[:space:]]+\\([_A-Za-z0-9]+\\)" 1 font-lock-function-name-face)
    ("action[[:space:]]+\\([_A-Za-z0-9]+\\)" 1 font-lock-function-name-face)
    (":[[:space:]]*\\([_A-Za-z0-9]+\\)" . font-lock-type-face)
    ))

;;(string-match "[^ {}]*{" "modify {")

(defvar ship-mode-syntax-table (make-syntax-table))
(setq ship-mode-syntax-table (make-syntax-table))

(modify-syntax-entry ?\/ ". 12b" ship-mode-syntax-table)
(modify-syntax-entry ?\n "> b" ship-mode-syntax-table)

(modify-syntax-entry ?\/ ". 14" ship-mode-syntax-table)
(modify-syntax-entry ?* ". 23" ship-mode-syntax-table)

;; you can cheat the function easily by putting several {/} in one line
(defun ship-indent-line ()
  "Indent current line as ship code"
  (interactive)
  (beginning-of-line)
  ;; rule 1: beginning of buffer: indent=0
  (if (bobp) (indent-line-to 0)
    (let (previndent)
            ;; get the indentation of the previous line
            (save-excursion
                (forward-line -1)
                (setq previndent (current-indentation))
                (if (looking-at "[^{}\n]*{[^\n}]*\n")
                        (progn (setq previndent (+ previndent 2))
                                     (message "found {"))
                    nil)
                )
            (if (looking-at "[^{}\n]*}")
                    (progn (setq previndent (- previndent 2))
                                     (message "found }"))
                nil)
            (indent-line-to previndent)
            )
        )
    )

(define-derived-mode ship-mode fundamental-mode
  (setq font-lock-defaults '((ship-font-lock-keywords)))
  (setq mode-name "ship")
  (set-syntax-table ship-mode-syntax-table)
  (setq-default tab-width 2)
  (setq indent-line-function 'ship-indent-line)
  (define-key global-map (kbd "RET") 'newline-and-indent)
)

